Creates a property

Permission level: read-write

POST /property

Operation id: PropertyService_CreateProperty

Tags: PropertyService

Security

  • Authorization (apiKey)
    • Bearer token

Responses

200 — A successful response.

Content type: application/json

default — An unexpected error response.

Content type: application/json

Request body

Required: Yes

application/json

Schema

PropertyTypeRequiredDescription
propertyKeystringNo
propertyValuesarrayNo
propertyCharacteristicsobjectNoThe property characteristics proto is to define if a property is not 'generic' in that it should not apply to everything when being retrieved by a key. By defining this we can limit the properties we returned by our requests to only those properties applicable to our application. For example, VIQ only wants to see resourceTypes and grants specific to VIQ and does not care to see resourceTypes being used by WFC. When they do a list properties for PERMISSION_RESOURCE_TYPE they can include the domain = VIQ and only resourceType properties for VIQ would be returned. Tenant would be if a particular tenant had special values just for it. We have no actual use cases for this yet. The 'parent' characteristics allow us to specify that a property is the 'child' of another property. The only current use case for this is with resourceTypes and grants. What this does is allow us to specify that certain grants are the child of a particular resourceType: so if you had a resourceType with value admin and domain VIQ, you would define the child grants with this in its characteristics: (parent_property_key=PERMISSION_RESOURCE_TYPE, parent_property_value=admin, parent_domain=VIQ).
{
  "type": "object",
  "properties": {
    "propertyKey": {
      "type": "string"
    },
    "propertyValues": {
      "type": "array",
      "items": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string"
          },
          "enabled": {
            "type": "boolean"
          },
          "friendlyName": {
            "type": "string"
          },
          "description": {
            "type": "string"
          },
          "creationTime": {
            "type": "string",
            "format": "date-time"
          }
        }
      }
    },
    "propertyCharacteristics": {
      "type": "object",
      "description": "The property characteristics proto is to define if a property is not 'generic' in that it should not apply to everything when being retrieved by a key.  By defining this we can limit the properties we returned by our requests to only those properties\napplicable to our application.  For example, VIQ only wants to see resourceTypes and grants specific to VIQ and does not care to see resourceTypes being used by WFC.  When they do a list properties for PERMISSION_RESOURCE_TYPE they can include the domain = VIQ and only\nresourceType properties for VIQ would be returned.  Tenant would be if a particular tenant had special values just for it.  We have no actual use cases for this yet.\n\nThe 'parent' characteristics allow us to specify that a property is the 'child' of another property.  The only current use case for this is with resourceTypes and grants.  What this does is allow us to specify that certain grants are the child of a particular resourceType:\nso if you had a resourceType with value admin and domain VIQ, you would define the child grants with this in its characteristics: (parent_property_key=PERMISSION_RESOURCE_TYPE, parent_property_value=admin, parent_domain=VIQ).",
      "properties": {
        "tenantId": {
          "type": "string"
        },
        "scope": {
          "type": "string"
        },
        "domain": {
          "type": "string"
        },
        "parentPropertyKey": {
          "type": "string"
        },
        "parentPropertyValue": {
          "type": "string"
        },
        "parentTenantId": {
          "type": "string"
        },
        "parentScope": {
          "type": "string"
        },
        "parentDomain": {
          "type": "string"
        }
      }
    }
  }
}

Response models

200 — A successful response.

Content type: application/json

Schema

PropertyTypeRequiredDescription
propertyobjectNo
{
  "type": "object",
  "properties": {
    "property": {
      "type": "object",
      "properties": {
        "properties": {
          "type": "object"
        }
      }
    }
  }
}

default — An unexpected error response.

Content type: application/json

Schema

PropertyTypeRequiredDescription
codeinteger (int32)No
messagestringNo
detailsarrayNo
{
  "type": "object",
  "properties": {
    "code": {
      "type": "integer",
      "format": "int32"
    },
    "message": {
      "type": "string"
    },
    "details": {
      "type": "array",
      "items": {
        "type": "object",
        "properties": {
          "@type": {
            "type": "string"
          }
        }
      }
    }
  }
}